%define with_dri 1
%define dri_target linux-dri-x86
%define src_dirs SRC_DIRS="glx/x11 mesa glu"

%define manpages gl-manpages-1.0.1
%define gitdate 20071127

%define OSMesaversion 7.1.0

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Mesa graphics libraries
Name: 		mesa
Version: 	7.1
Release: 	1
License: 	MIT/X11
Group: 		System/Libraries
URL: 		http://www.mesa3d.org
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Source0:	 mesa-%{gitdate}.tar.bz2
Source2: 	%{manpages}.tar.bz2

Patch1: 	mesa-7.1-kill-glw.patch
Patch2: 	mesa-7.1pre-osmesa-version.patch
Patch3: 	mesa-7.1-dri-driver-dir.patch
Patch4: 	mesa-6.5-dont-libglut-me-harder-ok-thx-bye.patch
Patch25: 	mesa-7.0-symlinks-before-depend.patch
Patch26: 	mesa-7.1-remove-getid-i915.patch

BuildRequires: 	pkg-config
%if %{with_dri}
BuildRequires: 	libdrm-devel >= 2.4.0-1
%endif
BuildRequires: 	libXxf86vm-devel
BuildRequires: 	expat-devel
BuildRequires: 	xorg-x11-proto-devel >= 7.1
BuildRequires: 	makedepend
BuildRequires: 	libXext-devel
BuildRequires: 	freeglut-devel
BuildRequires: 	libXdamage-devel libXfixes-devel


%description
Mesa

#-- libGL ------------------------------------------------------------
%package libGL
Summary: 	Mesa libGL runtime libraries and DRI drivers.
Group: 		System/Libraries
Provides: 	libGL
# libGL moved to xorg-x11-Mesa-libGL
Obsoletes: 	xorg-Mesa-libGL
# Conflict with the xorg-x11-libs too, just to be safe for file conflicts
Obsoletes: 	xorg-libs
%if %{with_dri}
Requires: 	libdrm >= 2.4.0
%endif

%description libGL
Mesa libGL runtime libraries and DRI drivers.
#-- libGL ------------------------------------------------------------

%package libGL-devel
Summary: 	Mesa libGL development package
Group: 		Development/Libraries
Requires: 	mesa-libGL = %{version}-%{release}
Requires: 	libX11-devel

Provides: 	libGL-devel

# libGL devel files moved to xorg-x11-devel for FC2, FC3, FC4
Obsoletes: 	xorg-devel

%description libGL-devel
Mesa libGL development package
#-- libGLU -----------------------------------------------------------
%package libGLU
Summary: 	Mesa libGLU runtime library
Group: 		System/Libraries

Provides: 	libGLU

# libGLU moved to xorg-x11-Mesa-libGLU for FC[2-4], RHEL4
Obsoletes: 	xorg-Mesa-libGLU
# Obsolete xorg-x11-libs too, just to be safe
Obsoletes: 	xorg-libs

%description libGLU
Mesa libGLU runtime library
#-- libGLU-devel -----------------------------------------------------
%package libGLU-devel
Summary: 	Mesa libGLU development package
Group: 		Development/Libraries
Requires: 	mesa-libGLU = %{version}-%{release}
Requires: 	libGL-devel

Provides: 	libGLU-devel

# libGLU devel files moved to xorg-x11-devel for FC2, FC3, FC4
Obsoletes: 	xorg-devel

%description libGLU-devel
Mesa libGLU development package

#-- libOSMesa -----------------------------------------------------------
%package libOSMesa
Summary: 	Mesa offscreen rendering libraries
Group: 		System/Libraries

Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig

Provides: 	libOSMesa

%description libOSMesa
Mesa offscreen rendering libraries

#-- libOSMesa-devel -----------------------------------------------------
%package libOSMesa-devel
Summary: 	Mesa offscreen rendering development package
Group: 		Development/Libraries
Requires: 	mesa-libOSMesa = %{version}-%{release}

%description libOSMesa-devel
Mesa offscreen rendering development package

#-- source -----------------------------------------------------------
%package source
Summary: 	Mesa source code required to build X server
Group: 		Development/Libraries
Obsoletes: 	xorg-Mesa-devel

%description source
The mesa-source package provides the minimal source code needed to
build DRI enabled X servers, etc.

#-- glx-utils --------------------------------------------------------
%package -n glx-utils
Summary: 	GLX utilities
Group: 		Development/Libraries

%description -n glx-utils
The glx-utils package provides the glxinfo and glxgears utilities.

%package demos
Summary: Mesa demos
Group: Development/Libraries

%description demos
This package provides some demo applications for testing Mesa.


%prep
%setup -q -n mesa-%{gitdate} -b2
chmod a-x progs/demos/glslnoise.c

%patch1 -p1 -b .kill-glw
%patch2 -p1 -b .osmesa-version
%patch3 -p1 -b .dri-driver-dir
%patch4 -p0 -b .dont-libglut-me-harder-ok-thx-bye
%patch25 -p1 -b .makej
%patch26 -p1 -b .fixi915

# WARNING: The following files are copyright "Mark J. Kilgard" under the GLUT
# license and are not open source/free software, so we remove them.
rm -f include/GL/uglglutshapes.h

# Hack the demos to use installed data files
sed -i -e 's,../images,%{_libdir}/mesa-demos-data,' progs/demos/*.c
sed -i -e 's,geartrain.dat,%{_libdir}/mesa-demos-data/geartrain.dat,' progs/demos/geartrain.c
sed -i -e 's,isosurf.dat,%{_libdir}/mesa-demos-data/isosurf.dat,' progs/demos/isosurf.c
sed -i -e 's,"terrain.dat","%{_libdir}/mesa-demos-data/terrain.dat",' progs/demos/terrain.c

%build
# The i965 DRI driver breaks if compiled with -O2.  It appears to be
# an aliasing problem, so we add -fno-strict-aliasing to the flags.
export OPT_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fvisibility=hidden -fPIC"
export DRI_DRIVER_DIR="%{_libdir}/dri"

mkdir preserve

for t in osmesa osmesa16 osmesa32; do
    echo "Building $t"
    make %{?_smp_mflags} linux-$t OPT_FLAGS="${OPT_FLAGS}" LIB_DIR=lib
    mv lib/* preserve
    make -s realclean LIB_DIR=lib
done

echo "Building %{dri_target}"
make %{?_smp_mflags} %{dri_target} OPT_FLAGS="${OPT_FLAGS}" LIB_DIR=lib %{src_dirs}
# We shouldn't built this libglut, but just to make sure...
make -C progs/xdemos glxgears glxinfo OPT_FLAGS="${OPT_FLAGS}" LIB_DIR=lib
make -C progs/demos OPT_FLAGS="${OPT_FLAGS}" LIB_DIR=lib
mv preserve/* lib
ln -s libOSMesa.so.6 lib/libOSMesa.so 
ln -s libOSMesa16.so.6 lib/libOSMesa16.so
ln -s libOSMesa32.so.6 lib/libOSMesa32.so

pushd .
cd ../%{manpages}
%configure
make %{?_smp_mflags}
popd



%install
rm -rf $RPM_BUILD_ROOT

# The mesa build system is broken beyond repair.  The lines below just
# handpick and manually install the parts we want.

rm include/GL/glut*.h
install -d $RPM_BUILD_ROOT%{_includedir}/GL
install -m 644 include/GL/{gl,o,x}*.h $RPM_BUILD_ROOT%{_includedir}/GL
install -d $RPM_BUILD_ROOT%{_includedir}/GL/internal
install -m 644 include/GL/internal/dri_interface.h $RPM_BUILD_ROOT%{_includedir}/GL/internal
rm -f $RPM_BUILD_ROOT%{_includedir}/GL/glfbdev.h

install -d $RPM_BUILD_ROOT%{_libdir}
cp -d -f lib/lib* $RPM_BUILD_ROOT%{_libdir}

install -d $RPM_BUILD_ROOT%{_bindir}
install -m 0755 progs/xdemos/glxgears $RPM_BUILD_ROOT%{_bindir}
install -m 0755 progs/xdemos/glxinfo $RPM_BUILD_ROOT%{_bindir}

find progs/demos/ -type f -perm /0111 |
    xargs install -m 0755 -t $RPM_BUILD_ROOT/%{_bindir}
install -d $RPM_BUILD_ROOT/%{_libdir}/mesa-demos-data
install -m 0644 progs/images/*.rgb $RPM_BUILD_ROOT/%{_libdir}/mesa-demos-data
install -m 0644 progs/demos/*.dat $RPM_BUILD_ROOT/%{_libdir}/mesa-demos-data

%if %{with_dri}
install -d $RPM_BUILD_ROOT%{_libdir}/dri
for f in i810 i915 i915tex i965 mach64 mga r128 r200 r300 radeon savage sis tdfx unichrome; do
    so=lib/${f}_dri.so
    test -e $so && echo $so
done | xargs install -m 0755 -t $RPM_BUILD_ROOT%{_libdir}/dri >& /dev/null || :
%endif

# Install man pages
pushd .
cd ../%{manpages}
make install DESTDIR=$RPM_BUILD_ROOT
popd

# Install the source needed to build the X server.  The egreps are just
# stripping out unnecessary dirs; only tricky bit is the [^c] to make sure
# .../dri/common is included.
%define mesasourcedir %{_datadir}/mesa/source
mkdir -p $RPM_BUILD_ROOT/%{mesasourcedir}
( find src -name \*.[ch] ; find include -name \*.h ) |
    egrep -v '^src/(glu|glw)' |
    egrep -v '^src/mesa/drivers/(directfb|dos|fbdev|glide|ggi|osmesa)' |
    egrep -v '^src/mesa/drivers/(windows|dri/[^c])' |
    xargs tar cf - --mode a=r |
	(cd $RPM_BUILD_ROOT/%{mesasourcedir} && tar xf -)


%clean
rm -rf $RPM_BUILD_ROOT

%check

%post libGL -p /sbin/ldconfig
%postun libGL -p /sbin/ldconfig
%post libGLU -p /sbin/ldconfig
%postun libGLU -p /sbin/ldconfig
%post libOSMesa -p /sbin/ldconfig
%postun libOSMesa -p /sbin/ldconfig

%files libGL
%defattr(-,root,root,-)
%{_libdir}/libGL.so.1
%{_libdir}/libGL.so.1.2

%if %{with_dri}
%dir %{_libdir}/dri
%{_libdir}/dri/*_dri.so
%endif

%files libGL-devel
%defattr(-,root,root,-)
%{_includedir}/GL/gl.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/glx.h
%{_includedir}/GL/glx_mangle.h
%{_includedir}/GL/glxext.h
%{_includedir}/GL/xmesa.h
%{_includedir}/GL/xmesa_x.h
%{_includedir}/GL/xmesa_xf86.h
%dir %{_includedir}/GL/internal
%{_includedir}/GL/internal/dri_interface.h
%{_libdir}/libGL.so
%{_datadir}/man/man3/gl[^uX]*.3gl.gz
%{_datadir}/man/man3/glX*.3gl.gz

%files libGLU
%defattr(-,root,root,-)
%{_libdir}/libGLU.so.1
%{_libdir}/libGLU.so.1.3.*

%files libGLU-devel
%defattr(-,root,root,-)
%{_libdir}/libGLU.so
%{_includedir}/GL/glu.h
%{_includedir}/GL/glu_mangle.h
%{_datadir}/man/man3/glu*.3gl.gz

%files libOSMesa
%defattr(-,root,root,-)
%{_libdir}/libOSMesa.so.6
%{_libdir}/libOSMesa.so.6.5.3
%{_libdir}/libOSMesa16.so.6
%{_libdir}/libOSMesa16.so.6.5.3
%{_libdir}/libOSMesa32.so.6
%{_libdir}/libOSMesa32.so.6.5.3

%files libOSMesa-devel
%defattr(-,root,root,-)
%{_includedir}/GL/osmesa.h
%{_libdir}/libOSMesa.so
%{_libdir}/libOSMesa16.so
%{_libdir}/libOSMesa32.so

# We constructed this dir carefully, so just slurp in the whole thing.
%files source
%defattr(-,root,root,-)
%{mesasourcedir}

%files -n glx-utils
%defattr(-,root,root,-)
%{_bindir}/glxgears
%{_bindir}/glxinfo

%files demos
%defattr(-,root,root,-)
%{_bindir}/arbfplight
%{_bindir}/arbfslight
%{_bindir}/arbocclude
%{_bindir}/bounce
%{_bindir}/clearspd
%{_bindir}/copypix
%{_bindir}/cubemap
%{_bindir}/drawpix
%{_bindir}/engine
%{_bindir}/fire
%{_bindir}/fogcoord
%{_bindir}/fplight
%{_bindir}/fslight
%{_bindir}/gamma
%{_bindir}/gearbox
%{_bindir}/gears
%{_bindir}/geartrain
%{_bindir}/glinfo
%{_bindir}/gloss
%{_bindir}/glslnoise
%{_bindir}/gltestperf
%{_bindir}/glutfx
%{_bindir}/ipers
%{_bindir}/isosurf
%{_bindir}/lodbias
%{_bindir}/morph3d
%{_bindir}/multiarb
%{_bindir}/paltex
%{_bindir}/pointblast
%{_bindir}/ray
%{_bindir}/readpix
%{_bindir}/reflect
%{_bindir}/renormal
%{_bindir}/shadowtex
%{_bindir}/singlebuffer
%{_bindir}/spectex
%{_bindir}/spriteblast
%{_bindir}/stex3d
%{_bindir}/streaming_rect
%{_bindir}/teapot
%{_bindir}/terrain
%{_bindir}/tessdemo
%{_bindir}/texcyl
%{_bindir}/texdown
%{_bindir}/texenv
%{_bindir}/texobj
%{_bindir}/trispd
%{_bindir}/tunnel
%{_bindir}/tunnel2
%{_bindir}/vao_demo
%{_bindir}/winpos
%{_libdir}/mesa-demos-data


%changelog
* Sat Jan 05 2008 Christian Metzen <metzench@ccux-linux.de> 7.1-1
- Version update
- moved libGlw to own package
* Mon Nov 12 2007 Stefan Gottwald <gotti@ccux-linux.de> 7.0.2-1
- version update
- used later git version as official tarballs won't compile
* Wed Oct 10 2007 Christian Metzen <metzench@ccux-linux.de> 7.0.1-2
- cleaned specfile, corrected package group for libOSMesa
* Mon Aug 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 7.0.1-1
- Version update
* Tue Jun 26 2007 Stefan Gottwald <gotti@ccux-linux.de> 7.0-2
- added xcb and nptl support patch
* Sat Jun 23 2007 Karsten Brockmann <arcam@ccux-linux.de> 7.0-1
- Version update
* Mon Jun 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 6.5.3-2
- reapplied Gottis remove-debug-symbols-patch
* Mon Jun 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 6.5.3-1
- Version update
* Sun Feb 18 2007 Karsten Brockmann <arcam@ccux-linux.de> 6.5.2-1
- Version update
* Fri Jan 26 2007 Stefan Gottwald <gotti@ccux-linux.de> 6.5.1-3
- removed mach64 from build because problems with libdrm > 2.0.2
- added patch to disable debug symbols in DRI Modules
* Mon Sep 11 2006 Christian Metzen <metzench@ccux-linux.de> 6.5.1-2
- adjusted obsoletes
* Sun Sep 10 2006 Christian Metzen <metzench@ccux-linux.de> 6.5.1-1
- Version update
* Sat Jul 01 2006 Christian Metzen <metzench@ccux-linux.de> 6.5-1
- Initial release
